var _excluded = ["uiType", "name", "index", "props", "tooltip", "label", "info", "errors", "visibleOn", "source", "newSourceParams", "externalComsMap", "form", "emitter", "showableOn"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
/* eslint-disable no-extra-boolean-cast */
import React, { useCallback, useEffect, useState, useMemo } from 'react';
import { Form, Tooltip } from 'antd';
import { QuestionCircleOutlined } from '@ant-design/icons';
import { getComByUiType } from "./helper";
import useRequest from "../common/use-request";
import "./form-item.less";
export default function CFFormItem(componentProps) {
  var _componentProps$uiTyp = componentProps.uiType,
    uiType = _componentProps$uiTyp === void 0 ? 'text' : _componentProps$uiTyp,
    name = componentProps.name,
    index = componentProps.index,
    props = componentProps.props,
    tooltip = componentProps.tooltip,
    label = componentProps.label,
    info = componentProps.info,
    errors = componentProps.errors,
    visibleOn = componentProps.visibleOn,
    source = componentProps.source,
    newSourceParams = componentProps.newSourceParams,
    externalComsMap = componentProps.externalComsMap,
    form = componentProps.form,
    emitter = componentProps.emitter,
    showableOn = componentProps.showableOn,
    formItemProps = _objectWithoutProperties(componentProps, _excluded);
  var _useState = useState(visibleOn ? visibleOn(form.getFieldsValue()) : true),
    _useState2 = _slicedToArray(_useState, 2),
    visible = _useState2[0],
    setVisible = _useState2[1];
  // const [showable, setShowable] = useState(true);
  // TODO
  // useEffect(() => {
  //   setShowable(showableOn ? form.getFieldValue(showableOn.name) === showableOn.value : true);
  // }, [showableOn && form.getFieldValue(showableOn.name), form.getFieldValue(showableOn?.name)])

  var _useState3 = useState(source === null || source === void 0 ? void 0 : source.params),
    _useState4 = _slicedToArray(_useState3, 2),
    sourceParam = _useState4[0],
    setSourceParams = _useState4[1];
  var _useRequest = useRequest(visible && source ? _objectSpread(_objectSpread({}, source), {}, {
      params: sourceParam || {}
    }) : undefined, {}, function (data) {
      return (data === null || data === void 0 ? void 0 : data.dataSource) || data;
    }),
    _useRequest2 = _slicedToArray(_useRequest, 2),
    remoteSource = _useRequest2[0],
    loading = _useRequest2[1];

  // Fetch the props you want to inject. This could be done with context instead.
  // const themeProps = useTheme();
  // debugger;
  var onComponentChange = useCallback(function () {
    emitter.dispatch('change');
    // console.log('onChange', form.getFieldsValue());
  }, []);
  var selfRefresh = useCallback(function () {
    var formValue = form.getFieldsValue();
    var nextVisible = visible;
    if (visibleOn) {
      nextVisible = visibleOn(formValue);
      setVisible(nextVisible);
    }
    if (nextVisible && newSourceParams) {
      setSourceParams(newSourceParams(formValue));
    }
  }, [form, visibleOn, newSourceParams]);

  // const onblurRefresh = useCallback(() => {
  //   const { setFieldsValue,getFieldsValue } = form;
  //   const formValue = getFieldsValue();
  //   if (!!onBlur) {
  //     debugger
  //     const freshValue = onBlur(formValue);
  //     setFieldsValue(freshValue);
  //   }

  // }, [form]);

  useEffect(function () {
    if (!visibleOn && !newSourceParams) {
      return;
    }
    selfRefresh();
    emitter.subscribe('change', selfRefresh);

    // const { visibleOn } = componentProps;

    if (visibleOn) {
      emitter.subscribe('visionchange', selfRefresh);
    }
  }, []);

  // const changeFormValue = useCallback(
  //   (formValue: any) => {
  //     form.setFieldsValue(formValue);
  //   },
  //   [form]
  // );

  // 获取组件类型，并设置相关Props
  var Com = getComByUiType(uiType, externalComsMap);
  var comProps = _objectSpread({}, props);
  if (source) {
    comProps.loading = loading;
    comProps.dataSource = remoteSource;
  }
  var showTipsUiType = ['select', 'radio', 'datepicker', 'date-range-picker', 'textarea', 'input', 'number', 'selectTag', 'selectUser', 'upload-file', 'upload-img', 'checkbox-group', 'text', 'date-picker', 'switch'];
  var isRequired = useMemo(function () {
    return formItemProps.required !== undefined ? formItemProps.required : !!(formItemProps.rules && formItemProps.rules.some(function (rule) {
      if (rule && _typeof(rule) === 'object' && rule.required && !rule.warningOnly) {
        return true;
      }
      if (typeof rule === 'function') {
        var ruleEntity = rule(form);
        return ruleEntity && ruleEntity.required && !ruleEntity.warningOnly;
      }
      return false;
    }));
  }, [formItemProps, form]);
  return visible ? /*#__PURE__*/React.createElement(Form.Item, {
    className: "cf-form-item",
    required: isRequired,
    label: !!label && /*#__PURE__*/React.createElement(React.Fragment, null, label, !!tooltip && /*#__PURE__*/React.createElement(Tooltip, {
      title: tooltip
    }, "\xA0", /*#__PURE__*/React.createElement(QuestionCircleOutlined, null)))
  }, /*#__PURE__*/React.createElement(Form.Item, _extends({
    noStyle: true,
    name: name,
    key: name || index
  }, formItemProps), /*#__PURE__*/React.createElement(Com, _extends({}, comProps, {
    form: form,
    onChange: onComponentChange
  }))), (props === null || props === void 0 ? void 0 : props.tips) && showTipsUiType.indexOf(uiType) > -1 && /*#__PURE__*/React.createElement("div", {
    style: {
      color: '#999',
      fontSize: '12px',
      wordBreak: 'break-all',
      paddingTop: '8px'
    }
  }, props === null || props === void 0 ? void 0 : props.tips)) : null;
}